commit c17873d83aaeed037fb5d039df2e6303d4b6a553
Author: Richard Biener <rguenther@suse.de>
Date:   Mon Nov 14 17:19:20 2022 +0100

    tree-optimization/107485 - fix non-call exception ICE with inlining
    
    Inlining performs a wrong non-call exception fixup for VEC_COND_EXPRs
    which on the branch fail to properly have the condition split out in
    the first place.
    
            PR tree-optimization/107485
            * tree-inline.c (remap_gimple_stmt): Use correct type for
            split out condition of [VEC_]COND_EXPRs.

diff --git a/gcc/tree-inline.c b/gcc/tree-inline.c
index c20c25ceb50..658b09c07d2 100644
--- a/gcc/tree-inline.c
+++ b/gcc/tree-inline.c
@@ -1979,11 +1979,10 @@ remap_gimple_stmt (gimple *stmt, copy_body_data *id)
 	     || gimple_assign_rhs_code (ass) == VEC_COND_EXPR)
 	    && gimple_could_trap_p (ass))
 	  {
-	    gassign *cmp
-	      = gimple_build_assign (make_ssa_name (boolean_type_node),
-				     gimple_assign_rhs1 (ass));
+	    tree def = make_ssa_name (TREE_TYPE (gimple_assign_rhs1 (ass)));
+	    gassign *cmp = gimple_build_assign (def, gimple_assign_rhs1 (ass));
 	    gimple_seq_add_stmt (&stmts, cmp);
-	    gimple_assign_set_rhs1 (ass, gimple_assign_lhs (cmp));
+	    gimple_assign_set_rhs1 (ass, def);
 	  }
     }
 

